
set term ^ ;

CREATE or ALTER PROCEDURE J_STATUS(
  VAR_JACKPOT_ID VARCHAR(40) CHARACTER SET WIN1250)
RETURNS(
  RES_POT_VALUE_CENTS BIGINT,
  RES_RELOAD_POT_VALUE_CENTS BIGINT,
  RES_JACKPOT_STATUS VARCHAR(10) CHARACTER SET WIN1250,
  RES_CLIENTS_IN INTEGER,
  RES_CLIENTS_WIN INTEGER,
  RES_CLIENTS_TIMEOUT INTEGER,
  RES_CLIENTS_OUT INTEGER,
  RES_RESULT SMALLINT,
  RES_CAPTION VARCHAR(100) CHARACTER SET WIN1250,
  RES_LUCKY_NUMBER INTEGER)
AS
DECLARE VARIABLE TMP_JACKPOT_STATUS VARCHAR(10);
BEGIN
  /* Procedure body */

  if ( VAR_JACKPOT_ID is null
  ) then
  begin
       RES_RESULT = -1;
       RES_CAPTION = 'Invalid input parameters';
       suspend;
       exit;
  end

  select POT_VALUE_MONEY*100,
         POT_RELOAD_MONEY*100,
         STATUS
  from JACKPOT_PHASE_DATA
  where JACKPOT_ID = :VAR_JACKPOT_ID
  into :RES_POT_VALUE_CENTS,
       :RES_RELOAD_POT_VALUE_CENTS,
       :RES_JACKPOT_STATUS;
  if ( RES_JACKPOT_STATUS is null ) then
  begin
       RES_CAPTION = :VAR_JACKPOT_ID||' jackpot was reset.';
       RES_POT_VALUE_CENTS = 0;
       RES_RELOAD_POT_VALUE_CENTS = 0;
       RES_JACKPOT_STATUS = 'RESET';
       RES_CLIENTS_IN = 0;
       RES_CLIENTS_WIN = 0;
       RES_CLIENTS_TIMEOUT = 0;
       RES_CLIENTS_OUT = 0;
       RES_RESULT = -2;
       SUSPEND;
       EXIT;
  end

  select count(STATUS)
  from JACKPOT_CLIENTS
  where STATUS = 'IN'
  and JACKPOT_ID=:VAR_JACKPOT_ID
  into :RES_CLIENTS_IN;

  select count(STATUS)
  from JACKPOT_CLIENTS
  where STATUS = 'WIN'
  and JACKPOT_ID=:VAR_JACKPOT_ID
  into :RES_CLIENTS_WIN;

  select count(STATUS)
  from JACKPOT_CLIENTS
  where STATUS = 'TIMEOUT'
  and JACKPOT_ID=:VAR_JACKPOT_ID
  into :RES_CLIENTS_TIMEOUT;

  select count(STATUS)
  from JACKPOT_CLIENTS
  where STATUS = 'OUT'
  and JACKPOT_ID=:VAR_JACKPOT_ID
  into :RES_CLIENTS_OUT;

  RES_CAPTION = :VAR_JACKPOT_ID||' jackpot status OK.';
  RES_RESULT = 0;
  SUSPEND;
END;
^

set term ; ^

commit work;
