#************************************************************************************
# INSTALL SCRIPT HEADER - just change UpdateName to something not used before...
#************************************************************************************

script_end(){
#exit 0;
	if [ $1 -ne 0 ]; then
		#sporocimo SMS
		#/RouletteMaster/sendsms.sh 38640333105 $UpdateName" error(return code $1)!"
		#sporocimo EMAIL
		cat $UpdateLogFileName | /RouletteMaster/send_email_to_all_event.sh "Error while installing USB Update $UpdateName. $2 See body for details..."

		#izpisemo sporocilo na postaje, da se je usb nastavitev pravilno namestila
		find /ClientHome/10.5.10.* -maxdepth 0 -type d -exec echo "echo SHOW_MESSAGEBOX USB Package $UpdateName FAILED!!!. $2" '>' '{}'/CMD/command_file  \; >script.sh
		chmod 777 script.sh
		./script.sh
		rm script.sh -rf
 
		exit $1;
	else
		#sporocimo SMS
		#/RouletteMaster/sendsms.sh 38640333105 $UpdateName" USB Update successfull!"
		#sporocimo EMAIL
		cat $UpdateLogFileName | /RouletteMaster/send_email_to_all_event.sh "USB Update $UpdateName was Installed. $2 See body for details..."

		#izpisemo sporocilo na postaje, da se je usb nastavitev pravilno namestila
		find /ClientHome/10.5.10.* -maxdepth 0 -type d -exec echo "echo SHOW_MESSAGEBOX USB Package $UpdateName loaded successfully. $2" '>' '{}'/CMD/command_file  \; >script.sh
		chmod 777 script.sh
		./script.sh
		rm script.sh -rf
 
		exit 0;
	fi;
}

WORKING_DIR=`pwd`

#nastavitve iz datotek
DefaultName="_NO_NAME"
UpdateName=`cat ./CONFIG/update_name`
if [ -z "$UpdateName" ]; then
	UpdateName=$DefaultName
fi;
UpdateNameNoSpaces="$(echo -e "${UpdateName}" | tr -d '[[:space:]]')"

OnlyRouletteName=`cat ./CONFIG/only_for_roulette_name`
OnlyLicensedTo=`cat ./CONFIG/only_for_licensed_to`
ThisRouletteName=`cat /RouletteMaster/ROULETTE_NAME`;
ThisLicensedTo=`cat /RouletteMaster/licensed.to`;
InstalledUpdatesDir="/RouletteMaster/Updates/installed/$UpdateNameNoSpaces/"
UpdateLogFileName=$InstalledUpdatesDir"/install.log"
PreInstallScript="./CONFIG/pre_install_script.sh"
PostInstallScript="./CONFIG/post_install_script.sh"

#naredimo mapo za log-namestitve, moramo jo narediti takoj, ker sicer ne moremo pisati log-a
mkdir -p $InstalledUpdatesDir
echo `date`: Script for $UpdateName started. > $UpdateLogFileName

echo "Checking..."
echo `date`: "Checking..." >> $UpdateLogFileName
if [ $DefaultName = $UpdateName ]; then 
#tukaj ponovno, da izpisemo warning v log, ker prej nismo imeli logfile-name
	echo "Warning: update name was not specified, using default USB_UPDATE_NO_NAME"
	echo `date`: "Warning: update name was not specified, using default USB_UPDATE_NO_NAME" >> $UpdateLogFileName
fi;

if [ -f $InstalledUpdatesDir"/installed" ]; then 
	echo $UpdateName" is already installed - REINSTALLING."
	echo `date`: $UpdateName" is already installed - REINSTALLING." >> $UpdateLogFileName
#	script_end 0; #update was already installed
fi;

if [ -n "$OnlyRouletteName" ]; then
    THIS=`echo $ThisRouletteName|tr '[:upper:]' '[:lower:]'`
    ONLY=`echo $OnlyRouletteName|tr '[:upper:]' '[:lower:]'`
    echo $THIS | grep $ONLY > /dev/null
    if [ $? -ne 0 ]; then
        echo "Invalid roulette name. Update is for $OnlyRouletteName, but this roulette is $ThisRouletteName"
        echo `date`: "Invalid roulette name. This package is meant for $OnlyRouletteName, but this roulette is $ThisRouletteName" >> $UpdateLogFileName
	script_end 1 "Invalid roulette name."
    else
	echo Roulette name check OK, update for $OnlyRouletteName, this is $ThisRouletteName
	echo `date`: Roulette name check OK. This package is for $OnlyRouletteName, and this is $ThisRouletteName >> $UpdateLogFileName
    fi;
else
	echo Roulette name check OK, update is for ALL ROULETTE names.
	echo `date`: Roulette name check OK. This package is for ALL roulette names. >> $UpdateLogFileName
fi;


if [ -n "$OnlyLicensedTo" ]; then
#    ce zelimo da licensed to bo case sensitive
#    echo $ThisLicensedTo | grep $OnlyLicensedTo > /dev/null
    THIS=`echo $ThisLicensedTo|tr '[:upper:]' '[:lower:]'`
    ONLY=`echo $OnlyLicensedTo|tr '[:upper:]' '[:lower:]'`
    echo $THIS | grep $ONLY > /dev/null
    if [ $? -ne 0 ]; then
        echo "Invalid license. Update is for $OnlyLicensedTo, but this roulette is licensed to $ThisLicensedTo"
        echo `date`: "Invalid license. This package is meant for $OnlyLicensedTo, but this roulette is licensed to $ThisLicensedTo" >> $UpdateLogFileName
	script_end 2 "Invalid license."
    else
	echo License check OK, update for $OnlyLicensedTo, this roulette is licensed to $ThisLicensedTo
	echo `date`: License check OK. This package is for $OnlyLicensedTo, and this roulette is licensed to $ThisLicensedTo >> $UpdateLogFileName
    fi;
else
	echo License check OK, update is for ALL ROULETTES licenses.
	echo `date`: License check OK. This package is for ALL licenses. >> $UpdateLogFileName
fi;

echo "Everything is ready, "$UpdateName" pending for install."
echo `date`: "Everything is ready, "$UpdateName" pending for install." >> $UpdateLogFileName
#echo "Press CTRL+C to cancel now.."
#sleep 5

echo "Update process started. Do not interrupt this process..."
echo "Please wait, installing..."

# shinhroniziramo datume datotek s casom na ciljnem sistemu
echo "Syncing package files modification time with system clock" 
echo `date`: "Syncing package files modification time with system clock"  >> $UpdateLogFileName
find . -exec /bin/touch '{}' \; #Recursive touch command

#pre install script 
echo "Running pre install script..."
echo `date`: "Running pre install script..." >> $UpdateLogFileName
if [ -n "$PreInstallScript" ]; then
	./$PreInstallScript
fi;
echo Done.
echo `date`: Done. >> $UpdateLogFileName


##izvedemo update database-a, predno ustavimo firebird
echo "Updating database, please wait..." 
echo `date`: "Updating database, please wait..."  >> $UpdateLogFileName
echo >> $UpdateLogFileName
echo `date`: "---------------DB_SCRIPT-----------------" >> $UpdateLogFileName

if [ -f UPDATE_DB.sql ]; then
#    /etc/sysconfig/network-scripts/ifdown eth0; #samo ce je potrebno

#    cat ./UPDATE_DB.sql  >> $UpdateLogFileName
    ./update_db.sh >> $UpdateLogFileName 2>&1

#    /etc/sysconfig/network-scripts/ifup eth0; #samo ce je potrebno
fi;

echo `date`: "-------------DB_SCRIPT_END---------------" >> $UpdateLogFileName
echo >> $UpdateLogFileName



#************************************************************************************
# INSTALL SCRIPT BODY -- write your update commands here
#************************************************************************************
#/sbin/service firebird stop
#sleep 10

#killall fbserver
#INSTALL RPMS
rpm --force -ivh RPMS/*.rpm


#kopiramo root
echo -n "Copying ./ROOT to /    ..."
echo `date`: "Copying ./ROOT to /    ..." >> $UpdateLogFileName
cp ./ROOT/* / -rf --reply=yes --preserve=all >> $UpdateLogFileName
echo "done."
echo `date`: "done." >> $UpdateLogFileName

#update KNOPPIX-a
CURRENT_DIR=`pwd`
echo -n "Copying ./ROOT_KNOPPIX to /mnt/tmp    ..."
echo `date`: "Copying ./ROOT_KNOPPIX to /mnt/tmp    ..." >> $UpdateLogFileName
/usr/bin/expect << End-Of-Session
spawn ssh root@127.0.0.1 -p 90

expect {
-timeout 1 "(yes/no)?" { send "yes\r" }
}

expect "assword:"
send "givelogin\r"

expect ":~#"
send "/bin/cp /FC5/$CURRENT_DIR/ROOT_KNOPPIX/* / -R -f --preserve=all\r"

expect ":~#"
send "/bin/chown 1000:1000 /home/knoppix -R\r"

expect ":~#"
send "exit\r"

interact
exit
End-Of-Session
echo "done."
echo `date`: "done." >> $UpdateLogFileName


#************************************************************************************
# INSTALL SCRIPT FOOTER - change command.sh..., and or phone_number
#************************************************************************************
#zapomnimo si, da smo ta update že namestili
echo OK. > $InstalledUpdatesDir"/installed"


#post install script - used for reboot, reboot playboards, etc.
echo "Running post install script..."
echo `date`: "Running post install script..." >> $UpdateLogFileName
if [ -n "$PostInstallScript" ]; then
	sleep 5 #da se vidi sporocilo na postajah, predno naredimo reboot
	./$PostInstallScript
fi;

echo Done.
echo `date`: Done. >> $UpdateLogFileName
echo `date`: $UpdateName" was successfully installed on this system." >> $UpdateLogFileName


script_end 0 "Package success."
